﻿Imports System.ServiceModel
Imports System.ServiceModel.Activation
Imports System.Runtime.Serialization
Imports System.Data.OleDb
Imports System.IO
Imports System.Drawing
Imports System.Drawing.Imaging

<ServiceContract(Namespace:="")>
<SilverLightFaultBehavior()>
<AspNetCompatibilityRequirements(RequirementsMode:=AspNetCompatibilityRequirementsMode.Allowed)>
Public Class WCFService

    <OperationContract()>
    Public Function GetAllEmp() As ImageEmployee()
        Dim _path As String = HttpContext.Current.Server.MapPath("~\App_Data\NWind.mdb")
        Dim Conn As New OleDbConnection("Provider=Microsoft.ACE.OLEDB.12.0;Data Source=" & _path & ";Persist Security Info=False;")
        Conn.Open()
        Dim Cmd As New OleDbCommand("Select EmployeeID, LastName, FirstName, Title, City, Country, Photo  from Employees", Conn)
        Dim Reader As OleDbDataReader = Cmd.ExecuteReader()

        Dim arrEmp As ImageEmployee() = New ImageEmployee(8) {}
        Dim count As Integer = 0

        While Reader.Read()
            Dim employee = New ImageEmployee()
            employee.EmployeeID = Reader.GetInt32(0)
            employee.LastName = Reader.GetString(1)
            employee.FirstName = Reader.GetString(2)
            employee.Title = Reader.GetString(3)
            employee.City = Reader.GetString(4)
            employee.Country = Reader.GetString(5)

            Dim blob As Byte() = New Byte((Reader.GetBytes(6, 0, Nothing, 0, Integer.MaxValue)) - 1) {}
            Reader.GetBytes(6, 0, blob, 0, blob.Length)

            Using ms = New MemoryStream()
                ms.Write(blob, 78, blob.Length - 78)
                Dim bmp As Bitmap = DirectCast(Image.FromStream(ms), Bitmap)
                Using msJpg = New MemoryStream()
                    bmp.Save(msJpg, ImageFormat.Jpeg)
                    employee.Photo = msJpg.GetBuffer()
                End Using
            End Using

            arrEmp(count) = employee
            count += 1
        End While

        Conn.Close()
        Return arrEmp
    End Function

End Class

<DataContract()> _
Public Class ImageEmployee
    <DataMember()> _
    Public Property EmployeeID() As Integer
        Get
            Return m_EmployeeID
        End Get
        Set(value As Integer)
            m_EmployeeID = value
        End Set
    End Property
    Private m_EmployeeID As Integer
    <DataMember()> _
    Public Property LastName() As String
        Get
            Return m_LastName
        End Get
        Set(value As String)
            m_LastName = value
        End Set
    End Property
    Private m_LastName As String
    <DataMember()> _
    Public Property FirstName() As String
        Get
            Return m_FirstName
        End Get
        Set(value As String)
            m_FirstName = value
        End Set
    End Property
    Private m_FirstName As String
    <DataMember()> _
    Public Property Title() As String
        Get
            Return m_Title
        End Get
        Set(value As String)
            m_Title = value
        End Set
    End Property
    Private m_Title As String
    <DataMember()> _
    Public Property City() As String
        Get
            Return m_City
        End Get
        Set(value As String)
            m_City = value
        End Set
    End Property
    Private m_City As String
    <DataMember()> _
    Public Property Country() As String
        Get
            Return m_Country
        End Get
        Set(value As String)
            m_Country = value
        End Set
    End Property
    Private m_Country As String
    <DataMember()> _
    Public Property Photo() As Byte()
        Get
            Return m_Photo
        End Get
        Set(value As Byte())
            m_Photo = value
        End Set
    End Property
    Private m_Photo As Byte()
End Class
